#include "stc8h.h"
#include <oled.h>
#include <ADC.h>
#include <stdio.h>

#define MAIN_Fosc       22118400L   //ʱ
#define T0_Value        65536-MAIN_Fosc/1000*2  //1T2
//ADC0

u16 V_Ref;
u16 V_Curr;
u32 Main_Time_Stamp=0;
u32 Vol_Result;
unsigned char Vol_Number[4];

u8 Key_Status=0;

bit QC3_Mode =0;
bit busy=0;
bit Main_Time_Switch=0;
bit Key_Detect=0;
bit Vol_Detect_Status=0;

sbit Key1=P5^1;
sbit Key2=P3^5;
sbit Key3=P3^6;

sbit D_N1=P5^3;	  //5.1K
sbit D_N2=P0^5;	  //22K
sbit D_P1=P0^6;	  //5.1K
sbit D_P2=P0^7;	  //22K

void Voltage_Detection();
void Key_Check();
void Display_Control();

extern unsigned char code num[];
extern unsigned char code QC3_Menu[];

void delay_ms(u16 ms)
{
	unsigned char i, j;
    do{
		i = 60;
		j = 1;
		do
		{
			while (--j);
		} while (--i);
    }while(--ms);
}
void Timer0_Isr(void) interrupt 1
{
	Main_Time_Stamp++;
	if(Main_Time_Stamp%100==0)
	{
		Key_Check(); 		
					
	}
	if(Main_Time_Stamp%300==0)
	{
		Voltage_Detection();
		Display_Control();
	}
}

void Timer0_Init(void)		//2@22.1184MHz
{
	AUXR |= 0x80;			//ʱʱ1Tģʽ
	TMOD &= 0xF0;			//öʱģʽ
	TL0 = T0_Value ;				//öʱʼֵ
	TH0 = T0_Value >>8;				//öʱʼֵ
	TF0 = 0;				//TF0־
	TR0 = 1;				//ʱ0ʼʱ
	ET0 = 1;				//ʹܶʱ0ж
}
void D_Init()
{
	D_P1=0;
	D_P2=0;
	D_N1=0;
	D_N2=0;
}

void QC2_05()
{
	D_P1=0;
	D_P2=1;
	D_N1=0;
	D_N2=0;
}
void QC2_09()
{
	D_P1=1;
	D_P2=1;
	D_N1=0;
	D_N2=1;	
}
void QC2_12()
{
	D_P1=0;
	D_P2=1;
	D_N1=0;
	D_N2=1;
}
void QC2_20()
{
	D_P1=1;
	D_P2=1;
	D_N1=1;
	D_N2=1;	
}
void QC3()
{
	D_P1=0;
	D_P2=1;
	D_N1=1;
	D_N2=1;
}
void QC3_UP()
{
	D_P1=1;
	delay_ms(5);
	D_P1=0;
}
void QC3_DOWN()
{
	D_N1=0;
	delay_ms(5);
	D_N1=1;
}
void Display_Control()
{									   
	Vol_Number[0]= V_Curr/1000%10;
	Vol_Number[1]= V_Curr/100%10; 
	Vol_Number[2]= V_Curr/10%10; 
	Vol_Number[3]= V_Curr%10;  

	NumberShow(Vol_Number[0], 60, 3, 0) ;	
	NumberShow(Vol_Number[1], 68, 3, 0) ;
	NumberShow(10, 76, 3, 0) ;	
	NumberShow(Vol_Number[2], 84, 3, 0) ;
	NumberShow(Vol_Number[3], 92, 3, 0) ;
	NumberShow(11, 100, 3, 0) ;		
}

void Key_Check()
{
	if(Key_Detect==0)
	{
		if(Key1==1) 
		{
			if(QC3_Mode)
			{
				QC2_05();
				delay_ms(300);
				QC3();
			}
			else
			{
				QC2_05();
			}
			Key_Status=1;
		}

		if(Key2==1)
		{
			if(QC3_Mode)
			{
				QC3_UP();
			}
			else
			{
				QC2_09();
			}
			Key_Status=2;
			
		}
		if(Key3==1)
		{
			if(QC3_Mode)
			{
				QC3_DOWN();
			}
			else
			{
				QC2_12();
			}
			
			Key_Status=3;
		}

		

		Key_Detect=0;

	}


}


void Voltage_Detection()
{
	unsigned char i;
	unsigned int Max_Value,Min_Value,Tmp_Value;

	V_Curr=0;
	V_Ref=0;

	for(i=0;i<9;i++)
	{
		Tmp_Value=Get_ADC12bitResult(0);
		if(i==0)
		{
		 	Max_Value=Tmp_Value;
			Min_Value=Tmp_Value;
		}
		V_Curr+=Tmp_Value;
		if(Tmp_Value>Max_Value) Max_Value=Tmp_Value;
		if(Tmp_Value<Min_Value) Min_Value=Tmp_Value;
	}

	V_Curr=V_Curr-Max_Value-Min_Value;	
	V_Curr=V_Curr/7;

	for(i=0;i<9;i++)
	{
		Tmp_Value=Get_ADC12bitResult(15);
		if(i==0)
		{
		 	Max_Value=Tmp_Value;
			Min_Value=Tmp_Value;
		}
		V_Ref+=Tmp_Value;
		if(Tmp_Value>Max_Value) Max_Value=Tmp_Value;
		if(Tmp_Value<Min_Value) Min_Value=Tmp_Value;
	}
	V_Ref=V_Ref-Max_Value-Min_Value;
	V_Ref=V_Ref/7;

	Vol_Result=(unsigned long)((V_Curr*521.0)/V_Ref*119.0/82.0);

	V_Curr=Vol_Result;
}	


void main(void)
{
	unsigned char i=0;
   	P0M1 = 0x00;   P0M0 = 0xE0;   //Ϊ׼˫
    P1M1 = 0x01;   P1M0 = 0x00;   //Ϊ׼˫
    P2M1 = 0x00;   P2M0 = 0x00;   //Ϊ׼˫
    P3M1 = 0x60;   P3M0 = 0x00;   //Ϊ׼˫
    P4M1 = 0x00;   P4M0 = 0x00;   //Ϊ׼˫
	P5M0 = 0x08;   P5M1 = 0x02;   //Ϊ׼˫
    P6M1 = 0x00;   P6M0 = 0x00;   //Ϊ׼˫
    P7M1 = 0x00;   P7M0 = 0x00;   //Ϊ׼˫

	Key1=0;
	Key2=0;
	Key3=0;
	
	ADC_Init();
	Timer0_Init();
	OLED_Init();

	OLED_ColorTurn(0);//0ʾ1 ɫʾ
  	//OLED_DisplayTurn(0);//0ʾ 1 Ļתʾ        

	OLED_Display_Off();
	OLED_Display_On();
	OLED_Clear_Left_To_Right();
  
	ES=1;
	EA=1;
	D_Init();
	QC2_12();
	delay_ms(1350);
	QC2_05();
	delay_ms(300);
	QC3_Mode=1;
	OLED_DrawImage(QC3_Menu);
	OLED_Update();
	
	while(1)
	{  			
		OLED_Update();							    
	}
}